import os
import sys



class LOCCounter:
    
    def __init__(self):
        self.LOCCounter_Directory = (__file__[:__file__.rfind("\\")])
        self.ProcessRawData_Directory = (self.LOCCounter_Directory[:self.LOCCounter_Directory.rfind("\\")])
        self.Root_Directory = (self.ProcessRawData_Directory[:self.ProcessRawData_Directory.rfind("\\")])
        self.Subject_Programs_Directory = self.Root_Directory+"\\Subject_Programs"
        
    # Programs, a list of subject program names, as expresse in Subject_Programs directory
    def countLOC(self,Programs):
        
        LOC = {}
        for Program in Programs:
            Program_Path = self.Subject_Programs_Directory + "\\" + Program + "\\Original_Program"
            self.NumberOfLOC = 0
            self._recursiveSearch(Program_Path)
            NumberOfLOC = self.NumberOfLOC
            LOC[Program] = NumberOfLOC 
        
        # print the Num LOC
        for Program in list(LOC.keys()):
            print(Program + "\t" + str(LOC[Program]))
            
                
            
    def _recursiveSearch(self, Directory): 
        
        Directory_Contents = os.listdir(Directory)
        
        for Item in Directory_Contents:
            Item_Path = Directory + "\\" + Item
            Item_is_Directory = os.path.isdir(Item_Path)
            
            if Item_is_Directory:
                self._recursiveSearch(Item_Path)
            else:
                if Item[-3:] == ".py":
                    NumberOfLines = self._countLOC(Item_Path)                    
                    self.NumberOfLOC = self.NumberOfLOC + NumberOfLines
                    
    def _countLOC(self,File_Path):
        
        File_Object = None
        Lines = None
        try: 
            File_Object = open(File_Path, "r")
            Lines = File_Object.readlines()
        except:
            raise Exception("Couldn't read " + File_Path)
        finally:
            if File_Object != None:
                File_Object.close()
        
        Counter = 0
        for Line in Lines:
            RemoveWhiteSpace = Line.strip()
            IsBlankLine = len(RemoveWhiteSpace) == 0
            if IsBlankLine:
                pass
            else:
                IsCommentLine = RemoveWhiteSpace[0] == "#"
                if IsCommentLine:
                    pass
                else:
                    Counter = Counter + 1 
        return Counter




# test code
# LOCCounter().countLOC(["K_n"])
#LOCCounter()._recursiveSearch("C:\\Users\\Krishna\\eclipse-workspace\\ExperimentInfrastructure\\Subject_Programs\\C_n_minus")
# test code
        












