import ProcessRawData.Oracles.PostProcessing.compareActualOutputsAgainstPredictedOutputs.common_statistics as common
import scipy.stats as stats
import sys
import warnings


class MannWhitneyU(common.common_statistics):

    def get_PostProcessor_Name(self):
        return "AvsP_MannWhitneyU"

    def _comparison(self, ActualOutputs, PredictedOutputs):        
        ReformattedActualOutputs = []
        for Output in ActualOutputs:
            try:
                ReformattedActualOutputs.append(float(Output))
            except:
                pass
             
             
        ReformattedPredictedOutputs = []
        for Output in PredictedOutputs:
            try: 
                ReformattedPredictedOutputs.append(float(Output))
            except:
                pass
        
         
        TestStatistic = str(stats.mannwhitneyu(ReformattedActualOutputs,ReformattedPredictedOutputs,alternative="two-sided"))
        Statistic = (TestStatistic[TestStatistic.find("=")+1: TestStatistic.find(",")])
        PValue = (TestStatistic[TestStatistic.rfind("=")+1:TestStatistic.rfind(")")])         
         
        return "Statistic="+Statistic + "\t" + "PValue="+PValue
        
        




#MannWhitneyU().compare("Experiment_6(TYPE=Oracle_RMO,RAW_DATA_FROM=Experiment_3)")
