import ProcessRawData.Oracles.PostProcessing.compareActualOutputsAgainstPredictedOutputs.common_statistics as common
import scipy.stats as stats
import sys
import warnings


class WilcoxonSignedRank(common.common_statistics):

    def get_PostProcessor_Name(self):
        return "AvsP_Wilcoxon"

    def _comparison(self, ActualOutputs, PredictedOutputs):        
        ReformattedActualOutputs = []
        for Output in ActualOutputs:
            try:
                ReformattedActualOutputs.append(float(Output))
            except:
                ReformattedActualOutputs.append(sys.maxsize)
             
             
        ReformattedPredictedOutputs = []
        for Output in PredictedOutputs:
            try: 
                ReformattedPredictedOutputs.append(float(Output))
            except:
                ReformattedPredictedOutputs.append(sys.maxsize)
        
        
        TestStatistic = str(stats.wilcoxon(ReformattedActualOutputs,ReformattedPredictedOutputs))
        Statistic = (TestStatistic[TestStatistic.find("=")+1: TestStatistic.find(",")])
        PValue = (TestStatistic[TestStatistic.rfind("=")+1:TestStatistic.rfind(")")])         
        
        return "Statistic="+Statistic + "\t" + "PValue="+PValue
        
        




#WilcoxonSignedRank().compare("Experiment_19(TYPE=Oracle_RMO,RAW_DATA_FROM=Experiment_4)")
