import ProcessRawData.Oracles.PostProcessing.readDataToBeProcessed as reader
import numpy
from abc import ABC, abstractmethod
import os
import sys

# For a given mutant, this class creates two lists. The first list is all of the actual outputs that were produced by the test suite, 
# and the second list is all of the predicted outputs that were produced by the test suite. 
class compareActualOutputsAgainstPredictedOutputs(ABC): 

    # Experiment_Folder_Name, a Type=Oracle experiment folder
    def compare(self,Experiment_Folder_Name, SignificanceThreshold_ForPValue):
        Data = reader.readData().get_Data_Oracle(Experiment_Folder_Name)
        
        Results = {}
        for Mutant in list(Data.keys()):
            Mutant_Name = Mutant
                        
            ActualOutputs = []
            PredictedOutputs = []
                        
            TestSuite = (Data[Mutant]["TestSuite"])
            for TestCase in list(TestSuite.keys()):                
                ActualOutputs.append(TestSuite[TestCase]["ActualOutput"])
                PredictedOutputs.append(TestSuite[TestCase]["PredictedOutput"])
            
                
            Results[Mutant_Name] = self._comparison(ActualOutputs, PredictedOutputs)
        
                
        self._save_Results(Experiment_Folder_Name, Results, SignificanceThreshold_ForPValue)
        
        
    
    # The user should implement a means of comparing the actual outputs and predicted outputs here, and return the results of comparison as a string
    @abstractmethod
    def _comparison(self, ActualOutputs, PredictedOutputs):
#         # test code        
#         ReformattedActualOutputs = []
#         for Output in ActualOutputs:
#             try:
#                 ReformattedActualOutputs.append(float(Output))
#             except:
#                 pass
#             
#             
#         ReformattedPredictedOutputs = []
#         for Output in PredictedOutputs:
#             try: 
#                 ReformattedPredictedOutputs.append(float(Output))
#             except:
#                 pass
#         
#         
#         return sum(ReformattedActualOutputs) + sum(ReformattedPredictedOutputs)
#         # test code
        pass
    @abstractmethod
    def get_PostProcessor_Name(self):
        pass

    @abstractmethod
    def _save_Results(self, Experiment_Folder_Name, Results, SignificanceThreshold_ForPValue):
        pass

            
            

            
            
            
        


        



        
        


# compareActualOutputsAgainstPredictedOutputs().compare("Experiment_6(TYPE=Oracle_RMO,RAW_DATA_FROM=Experiment_3)")
