import os



class readData:

    # Gets the contents of Raw_Data.txt from experiments of TYPE=Oracle_* 
    def get_Data_Oracle(self, Experiment_Folder_Name):
        Path = self._get_File_Path(Experiment_Folder_Name)
        Results = self._reformat_File(Path)
        
        
        # test code
#         Tables = ""
#         for Mutant in list(Results.keys()):
#             Mutant_Name = Mutant
#             Table_Header = Mutant_Name + "\n"
#             Table_Header = Table_Header + "Test Case Name" + "\t" +  "Actual Output" + "\t" + "Predicted Output" + "\t" + "Verdict" + "\n"
#             Table = Table_Header
#             TestSuite = (Results[Mutant]["TestSuite"])
#             for Test_Case in TestSuite:
#                 Test_Case_Name = Test_Case
#                 ActualOutput = TestSuite[Test_Case]["ActualOutput"]
#                 PredictedOutput = TestSuite[Test_Case]["PredictedOutput"]
#                 Verdict = TestSuite[Test_Case]["Verdict"]
#                 Table_Row = Test_Case_Name + "\t" + str(ActualOutput) + "\t" + str(PredictedOutput) + "\t" + str(Verdict) + "\n"
#                 Table = Table + Table_Row
#             Tables = Tables + Table + "\n"
#             
#         print(Tables)
        # test code
        
        
        return Results
        
        
        
        
        
        
        
        

    def _get_File_Path(self, Experiment_Folder_Name):

        if "TYPE=Oracle_" not in Experiment_Folder_Name:
            raise Exception("This method cannot process the supplied experiment")
        
        PostProcessing_Directory = __file__[:__file__.rfind("\\")]
        Oracles_Directory = PostProcessing_Directory[:PostProcessing_Directory.rfind("\\")]
        ProcessRawData = Oracles_Directory[:Oracles_Directory.rfind("\\")]
        Project_Root = ProcessRawData[:ProcessRawData.rfind("\\")]
        Experimental_Results_Directory = Project_Root + "\\Experimental_Results"
        Supplied_Folder = Experimental_Results_Directory + "\\" + Experiment_Folder_Name
        RequiredFile = Supplied_Folder + "\\Raw_Data.txt" 
        
        if os.path.exists(RequiredFile) == False:
            raise Exception("Could not find " + RequiredFile)
        
        return RequiredFile
    
    def _reformat_File(self, Path):
        
        FileObject = None
        File_Contents = None
        try:
            FileObject = open(Path, "r")
            File_Contents = FileObject.readlines()
        except:
            raise Exception("Could not open " + Path)
        finally:
            if FileObject != None:
                FileObject.close()

        CurrentMutant = None  
        Mutants = {}      
        for Line in File_Contents:
            
            if CurrentMutant == None:
                CurrentMutant = Line.strip()
                Mutants[CurrentMutant] = {"TestSuite":{}}
                continue
            
            if Line.strip() == "":
                CurrentMutant = None
                continue
            
            if CurrentMutant != None:
                if Line.strip().startswith("Test Case Name") == False:                    
                    TestCase = Line.split("\t")[0].strip()
                    Actual = Line.split("\t")[1].strip()
                    Predicted = Line.split("\t")[2].strip()
                    Verdict = Line.split("\t")[3].strip()
                    Mutants[CurrentMutant]["TestSuite"][TestCase] = {"ActualOutput":Actual,"PredictedOutput":Predicted,"Verdict":Verdict}

                    
        return Mutants
            
            
        






# readData().get_Data_Oracle("Experiment_6(TYPE=Oracle_RMO,RAW_DATA_FROM=Experiment_3)")

