import ProcessRawData.Oracles.RegressionOracle.Models.Models.UniformityModels as UniformityModels
import ProcessRawData.Oracles.Experiment_Manager.Experiment_Manager as EM
import numpy
import sys

class UniformityOracle(EM.Experiment_Manager):

    def get_Oracle_Name(self):
        return "RMO"

    def Oracle(self,Input, Output):
        ReformattedInput = (Input[Input.find("[")+1:Input.rfind("]")]).split(",")
        Floats = [] 
        for Element in ReformattedInput:
            Floats.append(float(Element.strip()))
        StandardDeviation = numpy.std(Floats)
        
        ActualOutput = (Output[0].strip())
        PredictedOutput = str(UniformityModels.Greenwood(StandardDeviation))
        
        Verdict = "N/A"
        if ActualOutput != PredictedOutput:
            Verdict = "N/A"        
        
        return {"ActualOutput":ActualOutput, "PredictedOutput":PredictedOutput,"Verdict":Verdict}
        





# test code
# Experiment_Folder_Name = "Experiment_3(Prog=K_n,TCG=UniformityStatistics,TestSuite=2,TimeOut=5)"
# TestSuiteGeneratorName = "UniformityStatistics"
# TestSuite_Number = "2"
# UniformityOracle().run_Experiment(Experiment_Folder_Name, TestSuiteGeneratorName, TestSuite_Number)
# test code







