import os
import json


class LoadTestSuite:
    
    # Input: Subject_Program_Name, the name of the subject program, as expressed in the Subject_Program's directory e.g. LCM
    #        TestSuite_Number, the actual number of the test suite you're interested in e.g. "3"
    # Process: Loads the test suite
    # Output: The test suite
    def LoadTestSuite(self, Subject_Program_Name, TestSuite_Number):
        
        # Find the specified test suite
        TestSuites_Directory = __file__[:__file__.rfind("\\")]
        Subject_Program_Directory = TestSuites_Directory + "\\" + Subject_Program_Name
        Test_Suites_Directory = Subject_Program_Directory + "\\Test_Suites" 
        
        TestSuiteFile = None
        for TestSuite in (os.listdir(Test_Suites_Directory)):
            if TestSuite.startswith("Test_Suite_"+str(TestSuite_Number)+"("):
                TestSuiteFile = Test_Suites_Directory + "\\" + TestSuite
                break
        
        # If you could not find the specified test suite, raise an exception
        if TestSuiteFile == None:
            raise Exception("Could not find test suite")
        
        # Otherwise load the test suite
        JSONFileObject = None
        TestSuite = None
        try:
            JSONFileObject = open(TestSuiteFile,"r")
            TestSuite = json.load(JSONFileObject)
        except:
            raise Exception("Could not load test suite")
        finally:
            if JSONFileObject != None:
                JSONFileObject.close()

        return TestSuite
    
    
    
    
    
    
    
    
    
    
# Test Code
# TestSuite = "C:\\Users\\Krishna\\eclipse-workspace\\NSQ_SQ_AvgFEP\\TestSuites\\LCM\\Test_Suites\\Test_Suite_3(MAIN_METHOD LCM;number1_BETWEEN 1,5;number2_BETWEEN 10,15).json"
# LoadTestSuite().LoadTestSuite("LCM", "3")
# Test Code



