import TestSuites.TestSuiteGenerator as TCG
import TestSuites.Common.Numbers.Integers as IntegerGeneration
import TestSuites.Common.Numbers.Floats as FloatGeneration
import TestSuites.Common.Distributions.NormalDistribution as NormalDistribution


class TestSuiteGenerator(TCG.TestSuiteGenerator):
    
    def __init__(self, Main_Method, Subject_Program_Name, IncludeGap = False):
        self.IncludeGap = IncludeGap
        super(TestSuiteGenerator, self).__init__(Main_Method, Subject_Program_Name)


    def set_Test_Case_Parameters(self):
        self.sample_size_lowerbound = 1000
        self.sample_size_upperbound = 1000
        self.mean_lowerbound = 0.5
        self.mean_upperbound = 0.5
        self.standarddeviation_lowerbound = 0
        self.standarddeviation_upperbound = 0.28
#         self.number_of_samples_lowerbound = 30
#         self.number_of_samples_upperbound = 30
        self.gap_lowerbound = None
        self.gap_upperbound = None
        
        #if self.Subject_Program_Name == "Cressie2" or self.Subject_Program_Name == "Pardo":
        if self.IncludeGap == True:
            self.gap_lowerbound = 3
            self.gap_upperbound = 3
        
        
    def get_Test_Case_Parameters(self):
        Param_1 = "MAIN_METHOD "+(self.Main_Method)
        Param_2 = "sample_size_BETWEEN "+str(self.sample_size_lowerbound) + "," + str(self.sample_size_upperbound)
        Param_3 = "mean_BETWEEN "+str(self.mean_lowerbound) + "," + str(self.mean_upperbound)
        Param_4 = "standarddeviation_BETWEEN "+str(self.standarddeviation_lowerbound) + "," + str(self.standarddeviation_upperbound)
#         Param_5 = "num_samples_BETWEEN "+str(self.number_of_samples_lowerbound) + "," + str(self.number_of_samples_upperbound)
        Param_6 = "gap_BETWEEN "+str(self.gap_lowerbound) + "," + str(self.gap_upperbound)
        Params = "("+Param_1+";"+Param_2+";"+Param_3+";"+Param_4+";"+Param_6+")"
        return Params
    
    def generateTestCase(self):
        
        SampleSize = IntegerGeneration.generate_Random_Integer(self.sample_size_lowerbound, self.sample_size_upperbound)
        Mean = FloatGeneration.generate_Random_Float(self.mean_lowerbound, self.mean_upperbound)
        StandardDeviation = FloatGeneration.generate_Random_Float(self.standarddeviation_lowerbound, self.standarddeviation_upperbound)
#         NumSamples = IntegerGeneration.generate_Random_Integer(self.number_of_samples_lowerbound, self.number_of_samples_upperbound)
                
        Sample = NormalDistribution.generateRandomSample_NormalDistribution(SampleSize, Mean, StandardDeviation, 0, 1)
        
        if self.IncludeGap == False: 
            TestCase = self.Main_Method + "(" + str(Sample) + ")"
        else:
            TestCase = self.Main_Method + "(" + str(Sample) + "," + str(IntegerGeneration.generate_Random_Integer(self.gap_lowerbound, self.gap_upperbound))+")"
        
        return TestCase







#test code
# test = TestSuiteGenerator("D_n_plus().computeStatistic", "D_n_plus", False)
# print(test.generateTestCase())
#test code







